%glr-parser
%token CASE DO ELSE END FN HANDLE IF IN LET OF OP RAISE THEN WHILE
%token VID LAB SCON pat ty dec
%left  ORELSE
%left  ANDALSO

%start exp

%%

/* Expressions and matches */
atexp:
    SCON
  | op VID
  | '{' exprow '}'
  | '{' '}'
  | '#' LAB
  | '(' ')'
  | '(' expcn2 ')'
  | '[' expcn ']'
  | '[' ']'
  | '(' expsn2 ')'
  | LET dec IN expsn END
  | '(' exp ')'
  ;
expcn:
    exp
  | expcn ',' exp
  ;
expcn2:
    exp ',' exp
  | expcn2 ',' exp
  ;
expsn:
    exp
  | expsn ';' exp
  ;
expsn2:
    exp ';' exp
  | expsn2 ';' exp
  ;

exprow:
    LAB '=' exp
  | exprow ',' LAB '=' exp
  ;

appexp:
    atexp
  | appexp atexp
  ;

infexp:
    appexp
  | infexp VID appexp
  ;

exp:
    infexp
  | exp ':' ty               %dprec 8
  | exp ANDALSO exp          %dprec 7
  | exp ORELSE exp           %dprec 6
  | exp HANDLE match         %dprec 5
  | RAISE exp                %dprec 4
  | IF exp THEN exp ELSE exp %dprec 3
  | WHILE exp DO exp         %dprec 2
  | CASE exp OF match        %dprec 1
  | FN match
  ;

match:
    mrule
  | match '|' mrule
  ;

mrule:
    pat "=>" exp
  ;

op:
    /* empty */
  | OP
  ;

%%
