/* ALGOL60 exerpt */
/* not NU(item_1), ambiguous */
%token ELSE POWER LPAR RPAR LOGEQ IMPLIES OR AND NOT
%token designational_expression if_clause logical_value variable
%token function_designator relation adding_operator unsigned_number
%token multiplying_operator
%%

expression
  : arithmetic_expression
  | boolean_expression
  | designational_expression
  ;

arithmetic_expression
  : simple_arithmetic_expression
  | if_clause simple_arithmetic_expression ELSE arithmetic_expression
  ;

simple_arithmetic_expression
  : term
  | adding_operator term
  | simple_arithmetic_expression adding_operator term
  ;

term
  : factor
  | term multiplying_operator factor
  ;

factor
  : primary
  | factor POWER primary
  ;

primary
  : unsigned_number
  | variable
  | function_designator
  | LPAR arithmetic_expression RPAR
  ;

boolean_expression
  : simple_boolean
  | if_clause simple_boolean ELSE boolean_expression
  ;

simple_boolean
  : implication
  | simple_boolean LOGEQ implication
  ;

implication
  : boolean_term
  | implication IMPLIES boolean_term
  ;

boolean_term
  : boolean_factor
  | boolean_term OR boolean_factor
  ;

boolean_factor
  : boolean_secondary
  | boolean_factor AND boolean_secondary
  ;

boolean_secondary
  : boolean_primary
  | NOT boolean_primary
  ;

boolean_primary
  : logical_value
  | variable
  | function_designator
  | relation
  | LPAR boolean_expression RPAR
  ;
