/* Java names */
/* See <http://java.sun.com/docs/books/jls/first_edition/html/19.doc.html#44469> */

%token ID
%token ArgumentListOpt VariableInitializer
%start BlockStatement

%%

/* 19.5 Productions from 6: Names */
Type
  : TypeName
  ;

TypeName
  : ID
  | PackageName '.' ID
  ;

PackageName
  : ID
  | PackageName '.' ID
  ;

MethodName
  : ID
  | AmbiguousName '.' ID
  ;

AmbiguousName
  : ID
  | AmbiguousName '.' ID
  ;

/* 19.11 Productions from 14: Blocks and Statements */

BlockStatement
  : LocalVariableDeclarationStatement
  | Statement
  ;

Statement
  : MethodInvocation
  ;

LocalVariableDeclarationStatement
  : Type VariableDeclarators ';'
  ;

VariableDeclarators
  : VariableDeclarator
  | VariableDeclarators ',' VariableDeclarator
  ;

VariableDeclarator
  : VariableDeclaratorId
  | VariableDeclaratorId '=' VariableInitializer
  ;

VariableDeclaratorId
  : ID
  | VariableDeclaratorId '[' ']'
  ;

/* 19.12 Productions from 15: Expressions */

MethodInvocation
  : MethodName '(' ArgumentListOpt ')'
  ;
