/* Language for syntax macros. */
/* Initial example in Culik and Cohen (1973) JCSS 7:66--96 */

%token EQUAL EQUIV IF THEN GOTO
%%
program
  : statement
  | program ';' statement
  ;

statement
  : assign_stat
  | jump
  | ident ':' statement
  ;

assign_stat
  : ident EQUAL arith_exp
  | ident EQUIV set_exp
  ;

jump
  : IF relation THEN GOTO ident
  ;

relation
  : arith_exp EQUAL arith_exp
  | set_exp EQUIV set_exp
  ;

arith_exp
  : arith_exp '+' arith_term
  | arith_exp '-' arith_term
  | arith_term
  ;

arith_term
  : arith_term '*' arith_primary
  | arith_primary
  ;

arith_primary
  : '(' arith_exp ')'
  | ident
  | const
  ;

set_exp
  : set_exp '+' set_term
  | set_term
  ;

set_term
  : set_term '*' set_factor
  | set_factor
  ;

set_factor
  : set_factor '-' set_primary
  | set_primary
  ;

set_primary
  : '(' set_exp ')'
  | ident
  | const
  ;

ident
  : ident letter
  | letter
  ;

const
  : const digit
  | digit
  ;

letter
  : 'a'
  | 'b'
  ;

digit
  : '0'
  | '1'
  ;
