/**
 * smlpattern.y
 *
 * Standard ML patterns.
 * See _The_definition_of_standard_ML_, Milner et al., 1997,
 * ISBN 0-262-63181-4.  Note that `ty' derives an infinite language.
 */

%token VID ty
%token AS
%start pat

%%

pat:
    VID                                 /* atomic pattern (value identifier) */
  | pat ':' ty                          /* typed pattern */
  | VID tyop AS pat                     /* layered pattern */
  ;

tyop:
    ':' ty
  | /* empty */
  ;

%%
